;******************************************************************
;			A digit reverse counter
;
;	Unscramble Data Order Sequence Of Radix-2 FFT
;	Length (must be a power of 2) is limited only by 
;	the amount of External RAM available and must be
;	a number less than 2**15
;
;******************************************************************

Unscramble

	CLR16	VarJloop	; J = 0
	clrf	VarIloop+B1
	MOVK	1,VarIloop	; I = 1	
nextI
	MOVK16	FftLen/2,VarKloop
	goto	testK
KlessJ				
	SUB16	VarKloop,VarJloop	; J = J - K
	RRC16	VarKloop		; K = K/2
testK
	MOV16	VarJloop,temp
	SUB16	VarKloop,temp		; temp = J - K	
	btfss	temp+B1,MSB		
	goto	KlessJ			; while K < J

	ADD16	VarKloop,VarJloop	; J = J + K
;
; if (i < j) then swap data(i) & data(j)
;
	MOV16	VarJloop,temp
	SUB16	VarIloop,temp		; temp = J - I 
	DEC16	temp
	btfsc	temp+B1,MSB		
	goto	incI			
;
; swap data
; read data(i)

	RLC16AB	VarIloop,tblptrl	; add twice the addr, since Real Data
	ADDLBL	ExtRamAddr,tblptrl	; is followed by Imag Data

	tablrd	0,1,Xi		; auto increment for Imag Data
	tlrd	0,Xi
	tlrd	1,Xi+B1		; real data XI
	tablrd	0,0,Yi
	tlrd	0,Yi
	tlrd	1,Yi+B1		; imag data YI
;
; read data(j)
;
	RLC16AB	VarJloop,tblptrl	; add twice the addr, since Real Data
	ADDLBL	ExtRamAddr,tblptrl	; is followed by Imag Data

	tablrd	0,1,Xl		; auto increment for Imag Data
	tlrd	0,Xl
	tlrd	1,Xl+B1		; real data XL
	tablrd	0,0,Yl
	tlrd	0,Yl
	tlrd	1,Yl+B1		; imag data YL
;
; Interchange data(I) & data(J)
;
; J addr already loaded into table pointers, bu autoincremented
;
	DEC16	tblptrl

	tlwt	0,Xi
	tablwt	1,1,Xi+B1		; auto increment for Imag Data
	tlwt	0,Yi
	tablwt	1,0,Yi+B1		; X(I) & Y(I) stored

	RLC16AB	VarIloop,tblptrl	; add twice the addr, since Real Data
	ADDLBL	ExtRamAddr,tblptrl	; is followed by Imag Data

	tlwt	0,Xl
	tablwt	1,1,Xl+B1		; auto increment for Imag Data
	tlwt	0,Yl
	tablwt	1,0,Yl+B1		; X(L) & Y(L) stored
;
; increment I
;
incI
	INC16	VarIloop

	MOVK16	DigitRevCount,temp
	SUB16	VarIloop,temp		; temp = DigitRevCount - I
	btfss	temp+B1,MSB		
	goto	nextI			; while i < DigitRevCount	
	return
;
; End digit reverse counter 
;
;*************************************************************************

